### Overview

This repository contains the code to compute all replicate all numerical results, including figures, in "Reconciling Models of Diffusion and Innovation: A Theory of the Productivity Distribution and Technology Frontier:" by Benhabib, Perla, and Tonetti (Econometrica 2021).

### Setup
- The code was tested with Matlab 2020b using the Parallel Computing toolbox
- Install [CompEcon](https://pfackler.wordpress.ncsu.edu/compecon/154-2/) and add it to your Matlab path


### Generating Figures
The following files generate the paper figures: `figures_4_5.m, figures_6_7_8.m, figures_9_13.m,` and `figures_10_11.m`

These primarily call either `solve_joint_endogenous.m` or `solve_joint_endogenous_max_g.m` for the calculations.

### Additional Files
- `solve_joint_endogenous.m`: Given parameters and settings, it
  - Uses compecon to calculate a Chebyshev basis and Chebyshev-Gauss quadrature scheme
  - Calls the Matlab nonlinear least squares solver to minimize the stacked residuals for the collocation coefficients. The kernel is the `joint_endogenous_L.m` function, which takes the parameters, settings, and a stacked list of all function coefficients
- `solve_joint_endogenous_max_g.m`: In order to find the maximum g in the endogenous innovation case, this file increases `z_bar` and repeatedly calls `solve_joint_endogenous.m` until a maximum is reached (or the problem becomes degenerate)
- `joint_endogenous_L.m`: Provides a residual calculation stacking the KFE, HJBE, boundary conditions, and value matching conditions. The optimizer minimizes its least-squares error
- `display_s.m, init_lib, set_output_figure_defaults.m` are general purpose utility files
- `baseline_joint_endogenous_settings.m` creates the default arguments and optimization parameters for the algorithms